﻿define("epi-ecf-ui/command/ViewArchive", [
    "dojo/_base/declare",
    "dojo/topic",
    //cms
    "epi/dependency",
    "epi/shell/command/_Command",
    // Resources
    "epi/i18n!epi/cms/nls/commerce.widget.archive"
], function (
    declare, 
    topic, 
    dependency,
    _Command, 
    res) {

    return declare([_Command], {
        // summary:
        //      A command that view archive list when executed.
        //
        // tags:
        //      public

        // label: [readonly] String
        //		The action text of the command to be used in visual elements.
        label: res.label,

        // iconClass: [readonly] String
        //		The icon class of the command to be used in visual elements.
        iconClass: "epi-iconArchive",

        postscript: function () {
            this.inherited(arguments);

            var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            this.rootId = this.rootId || contentRepositoryDescriptors.catalog.roots[0];
        },

        _execute: function () {
            // summary:
            //		Copies the currently selected items to the clipboard and sets the clipboard copy flag.
            // tags:
            //		protected
            topic.publish("/epi/shell/context/request", { uri: "epi.cms.contentdata:///" + this.rootId }, { viewName: "archivelistview" });
        },
        
        _onModelChange: function () {
            // summary:
            //		Updates canExecute after the model has been updated.
            // tags:
            //		protected

            this.set("canExecute", true);
            this.set("isAvailable", true);
        }
    });
});
