require({cache:{
'url:epi-ecf-ui/widget/templates/ArchiveList.html':"﻿<div class=\"epi-archived-list\">\r\n    <div class=\"epi-toolbarGroupContainer epi-archive-toolbar\">\r\n        <div class=\"epi-toolbarGroup epi-toolbarLeading\" style=\"width: 30%\" data-dojo-attach-point=\"leadingNode\"></div>\r\n        <div class=\"epi-toolbarGroup epi-toolbarTrailing\" data-dojo-attach-point=\"trailingNode\"></div>\r\n    </div>\r\n    <div data-dojo-attach-point=\"gridNode\"></div>\r\n</div>"}});
﻿define("epi-ecf-ui/widget/ArchiveList", [
    // Dojo
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/dom-construct",
    "dojo/dom-style",
    "dojo/topic",
    "dojo/when",

    // Dojox
    "dojox/widget/Standby",

    // dijit
    "dijit/layout/_LayoutWidget",
    "dijit/_TemplatedMixin",
    "dijit/form/Button",

    //Dgrid
    "dgrid/tree",
    "dgrid/OnDemandGrid",
    "dgrid/Selection",
    "epi/shell/dgrid/Formatter",
    "dgrid/extensions/ColumnResizer",
    "dgrid/selector",

    // Epi Shell
    "epi/shell/dgrid/util/misc",
    "epi/shell/widget/_FocusableMixin",
    "epi/shell/command/builder/ButtonBuilder",
    "epi/shell/widget/SearchBox",
    "epi/shell/widget/dialog/Dialog",

    // Epi CMS
    "epi/dependency",
    "epi/shell/TypeDescriptorManager",
    "epi/datetime",
    "epi-cms/command/_NonEditViewCommandMixin",
    "../contentediting/ModelSupport",

    // Epi Commerce
    "./_FullHeightContentMixin",
    "../command/RestoreArchive",
    "../command/DeleteArchive",
    "./viewmodel/ArchiveListModel",

    // Resources
    "dojo/text!./templates/ArchiveList.html",
    "epi/i18n!epi/cms/nls/commerce.widget.archive"
], function (
    // Dojo
    declare,
    lang,
    domConstruct,
    domStyle,
    topic,
    when,

    //dojox
    Standby,

    // dijit
    _LayoutWidget,
    _TemplatedMixin,
    Button,

    //Dgrid
    tree,
    OnDemandGrid,
    Selection,
    Formatter,
    ColumnResizer,
    selector,

    // Epi Shell
    GridMiscUtil,
    _FocusableMixin,
    ButtonBuilder,
    SearchBox,
    Dialog,

    // Epi CMS
    dependency,
    TypeDescriptorManager,
    epiDate,
    _NonEditViewCommandMixin,
    ModelSupport,
    
    // Epi Commerce
    _FullHeightContentMixin,
    RestoreArchive,
    DeleteArchive,
    ArchiveListModel,

    // Resources
    template,
    res) {

    return declare([_FocusableMixin, _LayoutWidget, _TemplatedMixin, _FullHeightContentMixin, _NonEditViewCommandMixin], {
        // summary:
        //    Lists the content of archive nodes.
        // tags:
        //    public
        resources: res,

        templateString: template,

        _builder: null,

        restoreButton: null,

        deleteButton: null,

        constructor: function () {
            this._builder = new ButtonBuilder({ settings: { showLabel: false } });
        },

        postCreate: function () {
            this.inherited(arguments);

            this._createModel();
            this._setupSearch();
            this._setupGrid();
            this._setupCommand();
            this._setupToolbarButton();
            this._setupEvents();
            
        },

        _createModel: function() {
            this.model = this.model || new ArchiveListModel();
        },

        _setupCommand: function() {
            this._deleteCommand = new DeleteArchive({ model: this.model, grid: this.grid });
            this._restoreCommand = new RestoreArchive({ model: this.model, grid: this.grid });
        },

        resize: function (changedSize) {
            // summary:
            //		Resize this widget to the given dimensions.
            // tags:
            //		protected

            this.inherited(arguments);

            domStyle.set(this.domNode, "height", changedSize.h + "px");
            if (this.grid) {
                // make the content 100% height its container
                this._setHeight(this.grid.domNode);
                this.grid.resize();
            }
        },

        _setQuery: function (searchText) {
            this.grid.set("query", { query: searchText });
        },

        _viewChanged: function (type, args, data) {
            if (data && data.viewName === "archivelistview") {
                this._setDisableToobarButton();
                this.searchBox.set("value", "");
                this._setQuery();
            }
        },
        
        _setupEvents: function () {
            this.inherited(arguments);
            
            this.own(
                this.grid.on("dgrid-deselect", function (e) {
                    this.updateSelection();
                    this._setDisableToobarButton();
                }.bind(this)),
                this.grid.on("dgrid-select", function (e) {
                    this.updateSelection();
                    this._setDisableToobarButton();
                }.bind(this))
            );
        },

        _setDisableToobarButton: function () {
            var hasSelectedItem = Object.values(this.grid.selection).length > 0;
            if (hasSelectedItem) {
                dojo.removeClass(this.restoreButton.domNode, "hide");
                dojo.removeClass(this.deleteButton.domNode, "hide");
                this.deleteButton.placeAt(this.trailingNode, "first");
                this.restoreButton.placeAt(this.trailingNode, "first");
            } else {
                dojo.addClass(this.restoreButton.domNode, "hide");
                dojo.addClass(this.deleteButton.domNode, "hide");
            }
        },

        _setupSearch: function () {
            this.searchBox = new SearchBox({
                "class": "epi-search",
                placeHolder: res.searchplaceholder,
                triggerChangeOnEnter: false
            });
            this.own(this.searchBox,
                this.searchBox.on("searchBoxChange",  this._setQuery.bind(this))
            );
            this.searchBox.placeAt(this.leadingNode, "first");
        },

        _setupToolbarButton: function () {
            this.restoreButton = new Button({
                label: res.restoreselected,
                "class": "epi-archive-toolbar-button epi-marketing-button epi-marketing-button__secondary hide",
                iconClass: "epi-iconRevert",
                onClick: function () {
                    this._restoreCommand.execute();
                }.bind(this)
            });

            this.deleteButton = new Button({
                label: res.deleteselected,
                "class": "epi-archive-toolbar-button epi-marketing-button epi-marketing-button__secondary hide",
                iconClass: "epi-iconTrash",
                onClick: function () {
                    this._deleteCommand.execute();
                }.bind(this)
            });

            this.deleteAllButton = new Button({
                label: res.deleteall,
                "class": "epi-archive-toolbar-button epi-marketing-button epi-marketing-button__secondary",
                iconClass: "epi-iconTrash",
                disabled: false,
                onClick: function () {
                    if (this.grid._total === 0) return;
                    var dialog = new Dialog({
                        dialogClass: "epi-dialog-confirm",
                        defaultActionsVisible: true,
                        content: res.deleteallconfirmmessage,
                        title: res.deleteall
                    });
                    this.own(dialog, dialog.on("execute", lang.hitch(this, this.deleteAll)));
                    dialog.show();
                }.bind(this)
            });
            this.deleteAllButton.placeAt(this.trailingNode);
        },

        deleteAll: function () {
            this._showStandby(true);
            var param = { action: ModelSupport.archivedAction.deleteAll };
            when(this.model.store.add(param), lang.hitch(this, this._refresh));
        },

        updateSelection: function () {
            var selection = [];

            for (var contentId in this.grid.selection) {
                var row = this.grid.row(contentId);
                selection.push(lang.mixin(row.data, { rowId: contentId }));
            }

            this.model.set("selections", selection);
        },

        _setupGrid: function () {
            var gridType = declare([OnDemandGrid, Selection, Formatter, ColumnResizer]);
            var columns = this._getColumns();
            this.grid = new gridType({
                store: this.model.store,
                columns: columns,
                noDataMessage: this._getNoDataMessage(),
                selectionMode: "single"
            });

            this._standby = new Standby({
                target: this.grid.domNode,
                color: "#fff",
                zIndex: 500,
                text: "<div class=\"oui-spinner\"></div>",
                centerIndicator: "text"
            }).placeAt(document.body);
            this._standby.startup();

            this.grid.noDataNode = this.noDataNode;
            this._setQuery();
            this.own(this.grid);
            domConstruct.place(this.grid.domNode, this.gridNode);
        },

        _getColumns: function () {
            // summary:
            //		Returns an object with the settings for the columns of the grid.
            // tags:
            //		private

            var columnSettings = this.inherited(arguments) || {};

            return lang.mixin({
                expando: tree({
                    label: "",
                    className:"epi-plain-grid",
                    sortable: false,
                    resizable: false,
                    shouldExpand: function (row, currentLevel, expanded) {
                        if (expanded) {
                            return true;
                        }

                        return false;
                    }
                }),
                checkbox: selector({
                    label: "",
                    selectorType: "checkbox"
                }),
                name: {
                    renderCell: function (item, value, node, options) {
                        return this._renderTreeNode(item, value, node);
                    }.bind(this),
                    label: res.namecolumn,
                    sortable: false,
                    resizable: false,
                    className: "epi-grid-column--left epi-grid--30",
                },
                archivedOn: {
                    formatters: [this._localizeDate, GridMiscUtil.ellipsis],
                    label: res.archiveon,
                    sortable: false,
                    resizable: false,
                    className: "epi-grid-column--left epi-grid--20",
                },
                archivedBy: {
                    get: function (object) {
                        return object.archivedBy;
                    },
                    label: res.archiveby,
                    sortable: false,
                    resizable: false,
                    className: "epi-grid-column--left epi-grid--20",
                },
                daysRemaining: {
                    get: function (object) {
                        return object.daysRemaining;
                    },
                    label: res.daysremaining,
                    sortable: false,
                    resizable: false,
                    className: "epi-grid-column--centered epi-grid--10",
                },
                action: {
                    className: "epi-grid-column--right epi-grid--10",
                    renderHeaderCell: function (node) { },
                    renderCell: function (object, value, node, options) {
                        var deleteCommand = new DeleteArchive({ model: this.model, grid: this.grid, object: object });
                        var restoreCommand = new RestoreArchive({ model: this.model, grid: this.grid, object: object });
                        this._builder.create(deleteCommand, node);
                        this._builder.create(restoreCommand, node);
                    }.bind(this),
                    sortable: false,
                    resizable: false,
                    label: res.action,
                }
            }, columnSettings);
        },

        _renderTreeNode: function (object, data, td) {
            var iconNodeClass = TypeDescriptorManager.getValue(object.typeIdentifier, "iconClass") || "epi-iconObjectVariation";
            domConstruct.place(GridMiscUtil.icon(iconNodeClass + " epi-objectIcon", GridMiscUtil.ellipsis(GridMiscUtil.htmlEncode(data))), td);
        },

        _localizeDate: function (value) {
            // summary:
            //      Returns localized, friendly date as string.
            // tags:
            //      private
            return epiDate.toUserFriendlyString(value);
        },

        _getStringValue: function (value) {
            // summary:
            //      Returns localized, friendly date as string.
            // tags:
            //      private
            return value;
        },

        _getNoDataMessage: function () {
            // summary:
            //      Get message in case have no data.
            // tags:
            //      private

            return "<span><span class=\"dijitReset dijitInline\">" + res.nodatamessage + "</span></span>";
        },

        _showStandby: function (visible) {
            // summary:
            //      Set standby visibility.
            // tags:
            //      private

            if (!this._standby) {
                return;
            }
            if (visible) {
                if (!this._standby.isVisible()) {
                    this._standby.show();
                }
            } else {
                this._standby.hide();
            }
        },

        _refresh: function () {
            this._showStandby(false);
            var contentRepositoryDescriptors = dependency.resolve("epi.cms.contentRepositoryDescriptors");
            var rootId = contentRepositoryDescriptors.catalog.roots[0];
            topic.publish("/epi/shell/context/request", { uri: "epi.cms.contentdata:///" + rootId }, { viewName: "archivelistview" });
        }
    });
});