define("epi-ecf-ui/widget/ArchiveToolbar", [
    "dojo/_base/declare",
    "dojo/_base/lang",
    "dojo/when",
    "epi/shell/widget/ToolbarSet",
// epi-ecf-ui
    "epi/i18n!epi/nls/commerce.widget.archive",
], function (declare,
    lang,
    when,
    ToolbarSet,
// epi-ecf-ui
    res
) {
    return declare([ToolbarSet], {
        // tags:
        //      public

        // currentContext: [public] Object
        //      An object with the current context information.
        currentContext: null,

        resources: res,

        // _setupPromise: [private] String
        //      The setup children promise.
        _setupPromise: null,

        groupNames: {
            leading: "leading",
            center: "center",
            trailing: "trailing"
        },

        buttonNames: {
            saveButton: "saveButton",
            closeButton: "closeButton"
        },

        viewName: null,

        buildRendering: function () {
            // summary:
            //      Constructs the toolbar container and starts the children setup process.
            // tags:
            //      protected

            this.inherited(arguments);

            // Setup the children items in the toolbar.
            // Update the toolbar items with the current model.
            when(this._setupPromise = this.setupChildren(), this.updateChildren.bind(this));
        },

        isSetup: function () {
            // summary:
            //      Wait for setup to finish.
            // tags:
            //      protected

            return this._setupPromise;
        },

        setupChildren: function () {
            // summary:
            //      Setup the items in the toolbar. Inheriting classes should extend this to add more items to the toolbar.
            // tags:
            //      protected

            var toolbarGroups = [
                {
                    name: this.groupNames.leading,
                    type: "toolbargroup",
                    settings: { region: "leading" }
                },
                {
                    name: this.groupNames.center,
                    type: "toolbargroup",
                    settings: { region: "center" }
                },
                {
                    name: this.groupNames.trailing,
                    type: "toolbargroup",
                    settings: { region: "trailing" }
                }];

            var toolbarItems = [];

            return this.add(toolbarGroups).then(function () {
                this.add(toolbarItems);
                return;
            }.bind(this));

        },

        updateChildren: function () {
            // summary:
            //      Update the toolbar items. This method is called on startup and whenever the current context is set.
            // tags:
            //      protected
            
        },

        update: function (data) {
            // summary:
            //      Update the toolbar with new data.
            // data:
            //      Toolbar data model. Expected properties are: currentContext
            // tags:
            //      public

            if (!data) {
                return;
            }

            this.currentContext = data.currentContext;
            this.viewConfigurations = data.viewConfigurations;

            when(this.isSetup(), this.updateChildren.bind(this));
        }
    });
});