define("epi-ecf-ui/widget/viewmodel/ArchiveListModel", [
    // dojo
        "dojo/_base/declare",
        "dojo/_base/lang",
        "dojo/Stateful",
    
        // EPi Framework
        "epi/dependency",
        "../../contentediting/ModelSupport"
    ], function (
    // dojo
        declare,
        lang,
        Stateful,
        // EPi Framework
        dependency,
        ModelSupport
    ) {
        return declare([Stateful], {
            // summary:
            // model:
            //    "epi-ecf-ui/widget/viewmodel/ArchiveListModel"
            // tags:
            //    public
    
            store: null,

            storeKey: "epi.commerce.archive",
    
            content: null,
    
            value: null,

            selections: [],
    
            postscript: function () {
                // summary:
                //      Post properties mixin handler.
                // description:
                //      Set up model and resource for template binding.
                // tags:
                //      protected
    
                this.inherited(arguments);
    
                var registry = dependency.resolve("epi.storeregistry");
                this.store = this.store || registry.get(this.storeKey);

                this._modifyStoreToHandleDgridTree();
            },
    
            _selectionsSetter: function (selection) {
                this.selections = selection;
            },

            _modifyStoreToHandleDgridTree: function () {
                // summary:
                //      getChildren and mayHaveChildren are needed on the store
                //      for dgrids tree module to work.
                // tags:
                //      private

                var self = this;
                this.store = lang.mixin(this.store, {
                    getChildren: function (parent) {
                        var nodeLink = parent.catalogNodeId > 0 ? parent.contentLink : parent.originalParentLink;
                        var entryLink = parent.catalogEntryId > 0 ? parent.contentLink : null;
                        var queryOptions = self._getQueryOptions(parent.archivedId, nodeLink, entryLink);
                        return this.query(queryOptions.queryParameters, queryOptions.queryOptions);
                    },
                    mayHaveChildren: function (parent) {
                        // This is only called by dgrids tree module and therefore we only want to do it on entries.
                        return parent.hasChildren;
                    }
                });
            },
    
            _getQueryOptions: function (archivedId, nodeLink, entryLink) {
                return {
                    queryOptions: { ignore: ["query"], archivedId: archivedId, nodeLink: nodeLink, entryLink: entryLink },
                    queryParameters: {
                        archivedId: archivedId,
                        nodeLink: nodeLink,
                        entryLink: entryLink
                    }
                };
            },
        });
    });
    